package db

import (
	"applet/app/db/model"
	"xorm.io/xorm"
)

type CentralKitchenWxTransferOrdList struct {
	Db         *xorm.Engine `json:"db"`
	OutTradeNo string       `json:"out_trade_no"`
}

func (centralKitchenWxTransferOrdListDb *CentralKitchenWxTransferOrdList) Set(outTradeNo string) { // set方法
	centralKitchenWxTransferOrdListDb.Db = Db
	centralKitchenWxTransferOrdListDb.OutTradeNo = outTradeNo
}

func (centralKitchenWxTransferOrdListDb *CentralKitchenWxTransferOrdList) BatchAddCentralKitchenWxTransferOrdListBySession(session *xorm.Session, mm []*model.CentralKitchenWxTransferOrdList) (int64, error) {
	affected, err := session.Insert(mm)
	if err != nil {
		return 0, err
	}
	return affected, nil
}
